package soln;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics2D;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Scanner;

import javax.swing.JFrame;

import type.lang.UniPanel;

public class Labtest04_Sec02_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		int width = 1000;
		int height = 500;

		/**
		 * [0 marks]: Step 0: This labtest requires the services of UniPanel,
		 * which is found in the type package. Check the statement
		 * "import type.lang.UniPanel;" above. If the compiler is giving a
		 * "The import type cannot be resolved" error, this means the build path
		 * of this project needs to be fixed. Do so if required
		 * (Project->Properties->Build Path, and then add the external jar
		 * called type.jar that was distributed with this project.
		 */

		/**
		 * This labtest is based on Lab8.2. This labtest assumes you have
		 * completed this lab and builds upon it.
		 * 
		 * 
		 * [2 marks] Step 1: do step 1 of Lab 8.2. Instead of using the method
		 * setSize(int, int), use the method setPreferredSize(Dimension). For
		 * this method, instantiate a Dimension object using the constructor
		 * that takes two ints. Use the int values width and height as declared
		 * above for width and height accordingly. The Dimension class can be
		 * found in the java.awt package. Also, place the statement that
		 * modifies the JFrame's size *before* the invocation of the pack()
		 * method.
		 */

		JFrame frame = new JFrame("My Frame");
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setVisible(true);
		frame.setPreferredSize(new Dimension(width, height));
		frame.pack();

		/**
		 * [1 mark] Step 2: do step 2 of Lab 8.2. This requires the services of
		 * the UniPanel class, which is found in the type package.
		 * 
		 * You will need to move the last statement from the code above this
		 * step (the statement that invokes the pack() method) to after the
		 * statement below that adds the UniPanel object to the content pane.
		 * 
		 */

		Container content = frame.getContentPane();
		UniPanel panel = new UniPanel();
		content.add(panel);
		frame.pack();

		/**
		 * [3 marks] Step 3: do not do step 3 of Lab 8.2, you should skip it
		 * altogether. Instead, do steps 4-5. Note that step 5 assumes you have
		 * created a Scanner object and appropriate references to the input and
		 * output streams of the console, so do this as well.
		 * 
		 * Hint: For step 6, the argument of the setColor method can be
		 * specified as Color.RED (or any one of a number of predefined colors;
		 * see the API of the Color class found in java.awt)
		 */
		Scanner input = new Scanner(System.in);
		Graphics2D canvas = panel.getGraphics2D();

		System.out.println("Enter any text to draw:");
		String str = input.nextLine();
		canvas.drawString(str, width / 3, height / 3);
		panel.repaint();

		/**
		 * [3 marks] Step 4: instead of steps 6-7 of Lab 8.2, do the following:
		 * 
		 * Change the color of the pen using the appropriate method of the
		 * Graphics2D object.
		 * 
		 * Change the font of the canvas using the appropriate method of the
		 * Graphics2D object and the new Font as specified in step 7, except use
		 * a font size that is one third of what is specified in step 7.
		 * 
		 * Choose a location to render the string a second time, any location
		 * that is within the bounds of the canvas, that is different than the
		 * location above, and that is more that 40 units away in the coordinate
		 * space, and that is in the upper left quadrant as measured from origin
		 * to origin (remember your trignometry!).
		 * 
		 * Cause the string to be rendered a second time by invoking the
		 * appropriate method that causes this to happen.
		 * 
		 * Avoid magic numbers.
		 */

		int fontSize = 15; // don't make this final size we will modify it below
		final int DISPLACEMENT = 25;
		final int PROPORTION = 3;

		canvas.setColor(Color.BLUE);
		Font font = new Font("Serif", Font.ITALIC, fontSize);
		canvas.setFont(font);
		canvas.drawString(str, width / PROPORTION - DISPLACEMENT, height
				/ PROPORTION - DISPLACEMENT);
		panel.repaint();

		/**
		 * [3 marks] Step 5: now instead of step 8, do the following:
		 * 
		 * Prompt the user for an integer value that is between 2 and 100;
		 * 
		 * For whichever value the user enters, cause the string to be rendered
		 * the specified number of times, *including* the rendering of the
		 * string in the previous step. The strings should be rendered in a
		 * diagonal arrangement, where the string rendered in the step above is
		 * the topmost string and the copies are printed below and to the right.
		 * Use a spacing of 30 between the strings horizontally and vertically.
		 * 
		 * Do not use magic numbers anywhere in the statements below.
		 */
		final int SPACING = 20;
		final int OFFSET = 20;
		System.out.println("Enter an integer (between 2 and 100):");
		int numTimes = input.nextInt();
		for (int i = 1; i < numTimes; i++) {
			canvas.setFont(font);
			canvas.drawString(str, width / PROPORTION + OFFSET + (i * SPACING),
					height / PROPORTION + OFFSET + (i * SPACING));

		}
		panel.repaint();

		/**
		 * [2 marks] Step 6: In the step above, modify the code so that the font
		 * size increases by 10% each time the string is printed. The font size
		 * is represented as an int, so you will need to find a way to implement
		 * this operation so that the result of the applying the scaling factor
		 * to the font size will be an int.
		 */

		final int GROWTH_SCALING = 10;
		System.out.println("Enter an integer (between 2 and 100):");
		numTimes = input.nextInt();
		for (int i = 1; i < numTimes; i++) {
			int increment = fontSize / GROWTH_SCALING;
			fontSize = fontSize + increment;
			font = new Font("Serif", Font.ITALIC, fontSize);
			canvas.setFont(font);
			canvas.drawString(str, width / PROPORTION + OFFSET + (i * SPACING),
					height / PROPORTION + OFFSET + (i * SPACING));

		}
		panel.repaint();

	}
}
